/***************************************************************************
            pluginconstants.h - constants for plugins (external C header)
                             -------------------
    begin                : Mon Sep 16 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__PLUGINCONSTANTS_H
#define INCLUDED__PLUGINCONSTANTS_H


/* Constants for msgcode argument of ebplugin_message function */
#define PLMSG_NULLEVENT            0  /* (just in case something stupid happens) */
#define PLMSG_PLUGINSTART          2  /* when plugin first starts running (after initialisation) */
#define PLMSG_BEFOREFIRSTPAGELOAD  7  /* before the first page is loaded */
#define PLMSG_BEFOREPAGECHANGE     8  /* before page is about to be changed (msgdata=(char *)name of new page)  */
#define PLMSG_AFTERPAGECHANGE      9  /* after page has been changed (msgdata=(char *)name of new page)         */
#define PLMSG_BEFOREFILELOAD       16 /* before a new XML file is about to be loaded (msgdata=(char *)filename) */
#define PLMSG_AFTERFILELOAD        17 /* after a new XML file is has been loaded (msgdata=(char *)filename)     */
#define PLMSG_COMM                 64 /* inter-plugin communication */

/* Constants for plugin state */
#define PLSTATE_NONEXISTENT     0
#define PLSTATE_CONSTRUCTING    1
#define PLSTATE_DORMANT         2
#define PLSTATE_INITIALISING    3
#define PLSTATE_RUNNING         4
#define PLSTATE_DEINITIALISING  5
#define PLSTATE_DESTRUCTING     6

/* Origin of plugin */
enum PLUGIN_ORIGIN {
  PLUGIN_ORIGIN_SYSTEM,
  PLUGIN_ORIGIN_FILE
};

#endif
